# vi: set softtabstop=2 ts=2 sw=2 expandtab:
# pylint:
#
import os
import sys
import mergeconf

# ---------------------------------------------------------------------------
#                                                     application variables
# ---------------------------------------------------------------------------

# application codename: short name used for tags, prefixes, etc.
name = 'STRAP Manager'
codename = 'strapper'

# ---------------------------------------------------------------------------
#                                                                   methods
# ---------------------------------------------------------------------------

def flatten_merged_config(config):
    """ Flatten mergeconf configuration into key-value dictionary for Flask.

    Hierarchical mergeconf configuration is flattened into a key-value lookup
    where each key represents the sections hierarchy followed by the item key,
    separated with underscores, and uppercased, so ['database']['uri'] becomes
    becomes 'DATABASE_URI', so that the configuration can be understood by
    Flask.
    """

    def flatten_dict(d, prefix=''):
        myd = {}
        for key, value in d.items():
            if isinstance(value, dict):
                myd.update(flatten_dict(value, prefix=f'{prefix}{key.upper()}_'))
            else:
                myd[f'{prefix}{key.upper()}'] = value
        return myd

    return flatten_dict(config.to_dict())


def determine_config(path, test_config=None):
    """ Determine application configuration from available sources

    Given instance path and optionally a test configuration, and assuming a
    configuration file at either the default location or overridden in the
    environment, as well as other variables set in the environment, build a
    merged application configuration from various sources and return as a flat
    key-value dictionary.

    Args:
        path (str): base path to look for files in their default locations, such
        as SQLite database file or configuration file.
        test_config (map): key-value pairs of configuration set for testing

    Returns:
        map: key-value pairs to be used as in Flask app configuration.
    """

    # determine default config file
    default_config_file = f"{path}/{codename}.conf"

    # determine configuraiton file to use
    config_file = default_config_file
    if test_config:
        config_file = test_config.get('CONFIG', config_file)
    config_file = os.environ.get(f'{codename}_CONFIG', config_file)

    # initialize configuration
    conf = mergeconf.MergeConf(codename, strict=True, files=config_file)

    deploy_conf = conf.add_section('deployment')
    deploy_conf.add('terraform', mandatory=True,
        description='Path to Terraform executable', cli=True)
    deploy_conf.add('chart', mandatory=True,
        description='Location of STRAP application Helm chart')

    # TODO: Will use this variable soon
    # pylint: disable-next=W0612
    db_conf = conf.add_section('database')
    # db_conf.add('host',
    #     description='Database host for STRAP applications')
    # db_conf.add('name',
    #     description='Database name for STRAP applications')
    # db_conf.add('user',
    #     description='Username for managing STRAP application databases')
    # db_conf.add('password',
    #     description='Password for user managing STRAP application databases')

    # kc_conf = conf.add_section('keycloak')
    # kc_conf.add('client_id', mandatory=True,
    #     description='Client ID for KeyCloak using client credentials grant (see' \
    #     ' https://registry.terraform.io/providers/mrparkers/keycloak/latest' \
    #     '/docs#client-credentials-grant-setup-recommended)')
    # kc_conf.add('client_secret', mandatory=True,
    #     description='Secret generated by Keycloak for client')
    # kc_conf.add('url', mandatory=True,
    #     description='URL for Keycloak instance')
    # kc_conf.add('base_path',
    #     description='Base path for authentication')

    # deployer_conf = conf.add_section('deployer')
    # deployer_conf.add('type', value='local')

    # TODO: merge in test config if specified
    # ...

    # merge configuration from various potential sources
    try:
        conf.merge()
    except mergeconf.exceptions.UndefinedSection as e:
        print("Unrecognized configuration section: %s", e.section)
        sys.exit(1)
    except mergeconf.exceptions.UndefinedConfiguration as e:
        print("Unrecognized configuration item: %s (section %s)", e.item, e.section)
        sys.exit(1)
    except mergeconf.exceptions.MissingConfigurationFile as e:
        print("Missing configuration file: %s", e.file)
        sys.exit(1)
    except mergeconf.exceptions.MissingConfiguration as e:
        print("Missing configuration items: %s", e.missing)
        sys.exit(1)

    return flatten_merged_config(conf)
